    function syntheticDefaultExportPolyfill(input){
        return input !== null && ['function', 'object', 'array']
            .indexOf(typeof input) > -1 && input.default === undefined ?
                 Object.isFrozen(input) ? input.default = input : Object.defineProperty(input, "default", {value : input, writable : true, enumerable : false}) : void 0;
    }
    if (typeof global === "object") {
        global.require = require;
    }
    var _a8cc = {};
    _a8cc.f = {}
    // cached modules
    _a8cc.m = {};
    _a8cc.s = function(id) {
        var result = _a8cc.r(id);
        if (result === undefined) {
            var result = require(id);
                syntheticDefaultExportPolyfill(result);
            return result;
        }
    }
    _a8cc.r = function(id) {
        var cached = _a8cc.m[id];
        // resolve if in cache
        if (cached) {
            return cached.m.exports;
        }
        var file = _a8cc.f[id];
        if (!file)
            return;
        cached = _a8cc.m[id] = {};
        cached.exports = {};
        cached.m = { exports: cached.exports };
        file.call(cached.exports, cached.m, cached.exports);
        syntheticDefaultExportPolyfill(cached.m.exports);
        return cached.m.exports;
    };
// default/index.js
_a8cc.f[0] = function(module,exports){
var __assign = this && this.__assign || Object.assign || function (t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s)
            if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
    }
    return t;
};
var __importDefault = this && this.__importDefault || function (mod) {
    return mod && mod.__esModule ? mod : { 'default': mod };
};
var __importStar = this && this.__importStar || function (mod) {
    if (mod && mod.__esModule)
        return mod;
    var result = {};
    if (mod != null)
        for (var k in mod)
            if (Object.hasOwnProperty.call(mod, k))
                result[k] = mod[k];
    result['default'] = mod;
    return result;
};
Object.defineProperty(exports, '__esModule', { value: true });
_a8cc.s('source-map-support').install({ environment: false ? 'browser' : 'node' });
_a8cc.s('array.prototype.move');
var SyncProvider_1 = __importDefault(_a8cc.r(1));
var DatabaseProvider_1 = __importDefault(_a8cc.r(2));
var sonicdb_1 = __importDefault(_a8cc.r(3));
var validate = __importStar(_a8cc.r(6));
var schema_1 = _a8cc.r(5);
var ObjectUtil = __importStar(_a8cc.r(9));
var utils = __importStar(_a8cc.r(10));
var distinct_1 = __importDefault(_a8cc.r(11));
var limit_1 = __importDefault(_a8cc.r(12));
var traverse = __importStar(_a8cc.r(13));
var queries_1 = __importDefault(_a8cc.r(16));
var schema_2 = __importDefault(_a8cc.r(5));
var listenerCollection_1 = __importDefault(_a8cc.r(23));
var network_1 = __importDefault(_a8cc.r(24));
var EventEmitter = _a8cc.s('eventemitter3');
module.exports = sonicdb_1.default;
module.exports.EventEmitter = EventEmitter;
module.exports.Queries = __assign({}, queries_1.default, {
    distinct: distinct_1.default,
    limit: limit_1.default,
    operators: queries_1.operators
});
module.exports.Utility = __assign({}, validate, utils, ObjectUtil, traverse, {
    normalizeSchemas: schema_1.normalize,
    toRawObject: schema_1.toRawObject,
    getQueryValueMatchers: queries_1.getQueryValueMatchers,
    getMatcherSets: queries_1.getMatcherSets,
    getOperatorImplementation: queries_1.getOperatorImplementation
});
module.exports.default = sonicdb_1.default;
module.exports.DatabaseProvider = DatabaseProvider_1.default;
module.exports.SyncProvider = SyncProvider_1.default;
module.exports.ListenerCollection = listenerCollection_1.default;
module.exports.Schema = schema_2.default;
module.exports.NetworkProvider = network_1.default;
module.exports.CursorProvider = DatabaseProvider_1.CursorProvider;
module.exports.CollectionProvider = DatabaseProvider_1.CollectionProvider;
if (typeof self !== 'undefined') {
    self.SonicDB = module.exports;
} else if (typeof global !== 'undefined') {
    global.SonicDB = module.exports;
}
}
// default/SyncProvider.js
_a8cc.f[1] = function(module,exports){
var __extends = this && this.__extends || function () {
    var extendStatics = Object.setPrototypeOf || { __proto__: [] } instanceof Array && function (d, b) {
        d.__proto__ = b;
    } || function (d, b) {
        for (var p in b)
            if (b.hasOwnProperty(p))
                d[p] = b[p];
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() {
            this.constructor = d;
        }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
}();
Object.defineProperty(exports, '__esModule', { value: true });
var EventEmitter = _a8cc.s('eventemitter3');
var SyncProvider = function (_super) {
    __extends(SyncProvider, _super);
    function SyncProvider() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    return SyncProvider;
}(EventEmitter);
exports.default = SyncProvider;
}
// default/DatabaseProvider.js
_a8cc.f[2] = function(module,exports){
var __extends = this && this.__extends || function () {
    var extendStatics = Object.setPrototypeOf || { __proto__: [] } instanceof Array && function (d, b) {
        d.__proto__ = b;
    } || function (d, b) {
        for (var p in b)
            if (b.hasOwnProperty(p))
                d[p] = b[p];
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() {
            this.constructor = d;
        }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
}();
Object.defineProperty(exports, '__esModule', { value: true });
var EventEmitter = _a8cc.s('eventemitter3');
var CursorProvider = function () {
    function CursorProvider() {
    }
    return CursorProvider;
}();
exports.CursorProvider = CursorProvider;
var CollectionProvider = function (_super) {
    __extends(CollectionProvider, _super);
    function CollectionProvider() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    return CollectionProvider;
}(EventEmitter);
exports.CollectionProvider = CollectionProvider;
var DatabaseProvider = function (_super) {
    __extends(DatabaseProvider, _super);
    function DatabaseProvider() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    return DatabaseProvider;
}(EventEmitter);
exports.default = DatabaseProvider;
}
// default/sonicdb.js
_a8cc.f[3] = function(module,exports){
var __extends = this && this.__extends || function () {
    var extendStatics = Object.setPrototypeOf || { __proto__: [] } instanceof Array && function (d, b) {
        d.__proto__ = b;
    } || function (d, b) {
        for (var p in b)
            if (b.hasOwnProperty(p))
                d[p] = b[p];
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() {
            this.constructor = d;
        }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
}();
var __importDefault = this && this.__importDefault || function (mod) {
    return mod && mod.__esModule ? mod : { 'default': mod };
};
Object.defineProperty(exports, '__esModule', { value: true });
var Table_1 = __importDefault(_a8cc.r(4));
var schema_1 = _a8cc.r(5);
var EventEmitter = _a8cc.s('eventemitter3');
var SonicDB = function (_super) {
    __extends(SonicDB, _super);
    function SonicDB(options) {
        var _this = _super.call(this) || this;
        _this.options = options;
        _this.provider = options.adapter;
        if (options.sync && options.sync.adapter) {
            _this.syncAdapter = options.sync.adapter;
            _this.provider.syncAdapter = _this.syncAdapter;
            if (options.sync.enabled && options.sync.autoStart !== false) {
                var adapter = options.sync.adapter;
                adapter.localAdapter = options.adapter;
                adapter.dbName = _this.provider.name;
                adapter.schemas = schema_1.toRawObject(_this.provider.options.schemas);
                adapter.on('sync:done', function () {
                    _this.emit('sync:done');
                });
                adapter.start();
            }
        }
        _this.provider.context = _this;
        return _this;
    }
    Object.defineProperty(SonicDB.prototype, 'isOpen', {
        get: function () {
            return this.provider.isOpen;
        },
        enumerable: true,
        configurable: true
    });
    SonicDB.prototype.collection = function (name) {
        var provider = this.provider;
        return provider.collection(name);
    };
    SonicDB.prototype.table = function (name) {
        return new Table_1.default(name, this.provider);
    };
    SonicDB.prototype.close = function () {
        this.provider.close();
        if (this.syncAdapter) {
            this.syncAdapter.stop();
        }
    };
    SonicDB.prototype.drop = function (name) {
        return this.provider.drop(name);
    };
    SonicDB.prototype.authenticate = function (opts) {
        return this.syncAdapter.authenticate(opts);
    };
    return SonicDB;
}(EventEmitter);
exports.default = SonicDB;
}
// default/Table.js
_a8cc.f[4] = function(module,exports){
Object.defineProperty(exports, '__esModule', { value: true });
var Table = function () {
    function Table(name, provider) {
        this.name = name;
        this.collection = provider.collection(name);
    }
    Table.prototype.select = function (q) {
        var args = arguments;
        if (args.length === 1) {
            if (typeof q === 'string' && q === '*') {
            } else if (typeof q === 'string') {
                q = q.split(',').map(function (str) {
                    return str.replace(' ', '');
                });
            }
        } else if (args.length > 1) {
        }
        return {
            distinct: function (str) {
                return {
                    from: function (tableName) {
                    }
                };
            },
            from: function (tableName) {
            }
        };
    };
    return Table;
}();
exports.default = Table;
}
// default/schema.js
_a8cc.f[5] = function(module,exports){
var __importDefault = this && this.__importDefault || function (mod) {
    return mod && mod.__esModule ? mod : { 'default': mod };
};
Object.defineProperty(exports, '__esModule', { value: true });
var isObject_1 = __importDefault(_a8cc.s('lodash/isObject'));
var validate_1 = _a8cc.r(6);
var types = [
    String,
    Object,
    Array,
    Number,
    Date
];
function addKey(schema, column, unique) {
    if (unique)
        return schema + ('&' + column + ',');
    else
        return schema + (column + ',');
}
function addPrimaryKey(schema, column, autoIncrement) {
    if (autoIncrement)
        return schema + ('++' + column + ',');
    else
        return schema + (column + ',');
}
function objectToSchemaString(columns) {
    var schema = '';
    var havePrimaryKey = false;
    var primaryKeyColumn;
    var autoIncrement = false;
    var indexes = [];
    for (var column in columns) {
        var typeOrProps = columns[column];
        if (!types.includes(typeOrProps) && isObject_1.default(typeOrProps)) {
            var keys = Object.keys(typeOrProps);
            validate_1.validateSchemaProps(keys);
            if (keys.includes('type') && !types.includes(typeOrProps['type']))
                throw new Error('type ' + typeOrProps['type'] + ' is not a known type');
            if (keys.includes('index')) {
                indexes.push(column);
            }
            if (keys.includes('primaryKey') || keys.includes('autoIncrement')) {
                if (havePrimaryKey)
                    throw new Error('only 1 primaryKey can be defined for each schema');
                if (keys.includes('autoIncrement') && !keys.includes('primaryKey'))
                    throw new Error('only primaryKey can use autoIncrement property');
                schema = addPrimaryKey(schema, column, keys.includes('autoIncrement'));
                primaryKeyColumn = column;
                havePrimaryKey = true;
                autoIncrement = keys.includes('autoIncrement');
                continue;
            }
            if (keys.includes('unique')) {
                schema = addKey(schema, column, true);
                continue;
            }
        } else {
            if (!types.includes(typeOrProps))
                throw new Error('type ' + typeOrProps + ' is not a known type');
            schema = addKey(schema, column, false);
        }
    }
    if (!havePrimaryKey) {
        schema = '++id,' + schema;
        primaryKeyColumn = 'id';
    }
    if (schema.endsWith(','))
        schema = schema.substr(0, schema.length - 1);
    schema = reorderSchema(schema, primaryKeyColumn);
    schema = buildCompoundIndex(schema, primaryKeyColumn, indexes);
    return {
        schema: schema,
        primaryKeyColumn: primaryKeyColumn,
        autoIncrement: autoIncrement
    };
}
function buildCompoundIndex(schema, primaryKeyColumn, indexes) {
    var splitted = schema.split(',');
    var compound = '';
    if (indexes.length > 0) {
        indexes.unshift(primaryKeyColumn);
        compound = '[' + indexes.join('+') + ']';
        splitted.push(compound);
        return splitted.join(',');
    } else {
        return schema;
    }
}
function reorderSchema(schema, primaryKeyColumn) {
    var splitted = schema.split(',');
    var i = 0;
    for (var _i = 0, splitted_1 = splitted; _i < splitted_1.length; _i++) {
        var field = splitted_1[_i];
        if ((field.includes('++') || field === primaryKeyColumn) && i !== 0) {
            if (splitted[0].includes('++') || splitted[0] === primaryKeyColumn) {
                throw new Error('multiple primaryKey is not supported');
            }
            splitted.move(i, 0);
        } else if (field === primaryKeyColumn && i !== 0) {
            splitted.move(i, 0);
        }
        i++;
    }
    return splitted.join(',');
}
function normalize(schemas) {
    var results = {};
    for (var schemaName in schemas) {
        var schema = schemas[schemaName];
        results[schemaName] = schema.raw;
    }
    return results;
}
exports.normalize = normalize;
function toRawObject(schemas) {
    var results = {};
    for (var schema in schemas) {
        results[schema] = {
            raw: schemas[schema].raw,
            primaryKeyField: schemas[schema].primaryKeyField,
            options: schemas[schema].options,
            fields: Object.keys(schemas[schema].fields),
            autoIncrementEnabled: schemas[schema].autoIncrementEnabled
        };
    }
    return results;
}
exports.toRawObject = toRawObject;
var Schema = function () {
    function Schema(obj, options) {
        this.options = options;
        if (arguments.length > 0) {
            if (!options || options.timestamp !== false) {
                options = Object.assign({}, options, { timestamp: true });
            }
            if (options.timestamp) {
                obj.createdAt = Date;
                obj.updatedAt = Date;
                this.withTimestamp = true;
            }
            this.fields = obj;
            var schm = objectToSchemaString(obj);
            this.raw = schm.schema;
            this.autoIncrementEnabled = schm.autoIncrement;
            this.primaryKeyField = schm.primaryKeyColumn;
        }
    }
    Schema.prototype.toMysqlTableQuery = function () {
    };
    return Schema;
}();
exports.default = Schema;
}
// default/utils/validate.js
_a8cc.f[6] = function(module,exports){
var __importDefault = this && this.__importDefault || function (mod) {
    return mod && mod.__esModule ? mod : { 'default': mod };
};
Object.defineProperty(exports, '__esModule', { value: true });
var schema_1 = __importDefault(_a8cc.r(5));
var isString_1 = __importDefault(_a8cc.r(7));
var util_1 = _a8cc.s('util');
var moment_1 = _a8cc.s('moment');
var isObject_1 = __importDefault(_a8cc.r(8));
var validSchemaProperty = [
    'unique',
    'primaryKey',
    'autoIncrement',
    'type',
    'index'
];
function validateSchemaProps(keys) {
    keys.forEach(function (key) {
        if (!validSchemaProperty.includes(key)) {
            throw new Error('property ' + key + ' is not a known property');
        }
    });
}
exports.validateSchemaProps = validateSchemaProps;
function validateSchema(schemas) {
    for (var key in schemas) {
        if (!(schemas[key] instanceof schema_1.default)) {
            throw new Error(key + ' schema is not valid schema');
        }
    }
}
exports.validateSchema = validateSchema;
function validatePopulate(obj) {
    if (!obj.hasOwnProperty('localField'))
        throw new Error('populate should have localField property');
    if (!obj.hasOwnProperty('foreignField'))
        throw new Error('populate should have foreignField property');
    if (!obj.hasOwnProperty('ref'))
        throw new Error('populate should have from property');
}
exports.validatePopulate = validatePopulate;
function validatePopulates(arr) {
    for (var _i = 0, arr_1 = arr; _i < arr_1.length; _i++) {
        var obj = arr_1[_i];
        validatePopulate(obj);
    }
}
exports.validatePopulates = validatePopulates;
function validateData(data, schema) {
    if (data === null || data === 'undefined') {
        throw new Error('cannot validate data with null or undefined value');
    }
    Object.keys(data).forEach(function (key) {
        var fields = schema.fields;
        var field = fields[key];
        var type = field.type || field;
        switch (type) {
        case String:
            if (!isString_1.default(data[key])) {
                throw new Error('column ' + key + ' expected to have type of string but ' + typeof data[key] + ' given.');
            }
            break;
        case Number:
            if (!util_1.isNumber(data[key])) {
                throw new Error('column ' + key + ' expected to have type of number but ' + typeof data[key] + ' given.');
            }
            break;
        case Array:
            if (!Array.isArray(data[key])) {
                throw new Error('column ' + key + ' expected to have type of array but ' + typeof data[key] + ' given.');
            }
            break;
        case Date:
            if (!moment_1.isDate(data[key])) {
                throw new Error('column ' + key + ' expected to have type of date but ' + typeof data[key] + ' given.');
            }
            break;
        case Object:
            if (!isObject_1.default(data[key])) {
                throw new Error('column ' + key + ' expected to have type of object but ' + typeof data[key] + ' given.');
            }
            break;
        }
    });
}
exports.validateData = validateData;
function isFirestoreTimestamp(obj) {
    var keys = Object.keys(obj);
    return keys.includes('nanoseconds') && keys.includes('seconds') && typeof obj.toDate === 'function';
}
exports.isFirestoreTimestamp = isFirestoreTimestamp;
}
// default/utils/isString.js
_a8cc.f[7] = function(module,exports){
Object.defineProperty(exports, '__esModule', { value: true });
function default_1(str) {
    return typeof str === 'string';
}
exports.default = default_1;
}
// default/utils/isObject.js
_a8cc.f[8] = function(module,exports){
Object.defineProperty(exports, '__esModule', { value: true });
function default_1(str) {
    return typeof str === 'object';
}
exports.default = default_1;
}
// default/utils/objects.js
_a8cc.f[9] = function(module,exports){
Object.defineProperty(exports, '__esModule', { value: true });
var DatabaseProvider_1 = _a8cc.r(2);
function isSnapshot(doc) {
    var keys = Object.keys(doc);
    return keys.includes('_document') && keys.includes('_key') && keys.includes('_firestore');
}
function wrapObject(obj, collection) {
    var doc = obj;
    if (isSnapshot(doc)) {
        doc = Object.assign(doc.data(), { id: doc.id });
    }
    return Object.assign(doc, {
        delete: function () {
            if (collection instanceof DatabaseProvider_1.CollectionProvider)
                return collection.remove({ id: doc.id });
            else
                return collection.doc(doc.id).delete();
        },
        update: function (data) {
            var id = data.id || doc.id;
            delete data.delete;
            delete data.update;
            delete data.id;
            if (collection instanceof DatabaseProvider_1.CollectionProvider)
                return collection.update({ id: id }, data);
            else
                return collection.doc(id).update(data);
        }
    });
}
exports.wrapObject = wrapObject;
}
// default/utils/util.js
_a8cc.f[10] = function(module,exports){
Object.defineProperty(exports, '__esModule', { value: true });
function createWorker(workerFunc, imports) {
    if (imports === void 0) {
        imports = [];
    }
    if (!(workerFunc instanceof Function)) {
        throw new Error('Argument must be function');
    }
    var src = '';
    imports.forEach(function (i) {
        var script = createWorkerImportScript(i);
        src += 'importScripts(\'' + script + '\');\n    ';
    });
    src += '(\n    ' + workerFunc + '\n  )();';
    var blob = new Blob([src], { type: 'application/javascript' });
    var url = URL.createObjectURL(blob);
    return new Worker(url);
}
exports.createWorker = createWorker;
function createWorkerImportScript(scriptFn) {
    if (!(scriptFn instanceof Function)) {
        throw new Error('Argument must be function');
    }
    var src = '(' + scriptFn + ')();';
    var blob = new Blob([src], { type: 'application/javascript' });
    var url = URL.createObjectURL(blob);
    return url;
}
exports.createWorkerImportScript = createWorkerImportScript;
function isWorkerAvailable() {
    var satisfied = true;
    if (typeof window === 'undefined' || typeof Worker === 'undefined') {
        var keys = Object.keys(Worker.prototype);
        if (keys.length < 4)
            satisfied = false;
    }
    return satisfied;
}
exports.isWorkerAvailable = isWorkerAvailable;
function isNodejs() {
    return new Function('try {return this===global;}catch(e){return false;}') && typeof process === 'object' && typeof process.versions === 'object' && typeof process.versions.node !== 'undefined';
    ;
}
exports.isNodejs = isNodejs;
function isBrowser() {
    return new Function('try {return this===window;}catch(e){ return false;}');
}
exports.isBrowser = isBrowser;
function workerScriptPath() {
    var currentScript = document.querySelector('script[src*="sonicdb"]');
    var src = currentScript.src;
    var regex = /https?:\/\//;
    var withDomain = regex.test(src);
    var path = src.replace(regex, '').split('/');
    if (withDomain || path[0].length < 1) {
        path.shift();
    }
    path.pop();
    if (path.length < 1) {
        return '/' + 'worker.js';
    }
    return '/' + path.join('/') + '/worker.js';
}
exports.workerScriptPath = workerScriptPath;
function isInWorker() {
    return typeof document === 'undefined' && typeof window === 'undefined';
}
exports.isInWorker = isInWorker;
function isNestedQuery(spec) {
    return Object.keys(spec).some(function (key) {
        if (key === '$and' || key === '$or' || key === '$nor' || key === '$nan') {
            return spec[key].some(function (field) {
                return Object.keys(field).some(function (name) {
                    var splitted = name.split('.');
                    return splitted.length > 0;
                });
            });
        }
    });
}
exports.isNestedQuery = isNestedQuery;
}
// default/queries/distinct.js
_a8cc.f[11] = function(module,exports){
var __importDefault = this && this.__importDefault || function (mod) {
    return mod && mod.__esModule ? mod : { 'default': mod };
};
Object.defineProperty(exports, '__esModule', { value: true });
var get_1 = __importDefault(_a8cc.s('lodash/get'));
var queuePrefix = 'distinct.';
function distinctQueue(spec) {
    return function (items, keys) {
        keys = keys.filter(function (k) {
            return k.startsWith(queuePrefix);
        }).map(function (k) {
            return k.replace(queuePrefix, '');
        });
        var availableItems = {};
        return items.filter(function (item) {
            return keys.every(function (key) {
                if (!availableItems[key])
                    availableItems[key] = [];
                var satisfied = !availableItems[key].includes(get_1.default(item, key));
                if (satisfied) {
                    availableItems[key].push(get_1.default(item, key));
                }
                return satisfied;
            });
        });
    };
}
function distinct(db, results, spec, queue) {
    if (results === void 0) {
        results = [];
    }
    var availableItems = {};
    var keys = Array.isArray(spec) ? spec : spec.keys;
    var promise = Promise.resolve(results);
    return promise.then(function (items) {
        var _loop_1 = function (key) {
            if (!availableItems[key])
                availableItems[key] = [];
            if (key.split('.').length > 1) {
                queue[queuePrefix + key] = distinctQueue(spec);
                return 'continue';
            }
            items = items.filter(function (item) {
                var satisfied = !availableItems[key].includes(get_1.default(item, key));
                if (satisfied) {
                    availableItems[key].push(get_1.default(item, key));
                }
                return satisfied;
            });
        };
        for (var _i = 0, keys_1 = keys; _i < keys_1.length; _i++) {
            var key = keys_1[_i];
            _loop_1(key);
        }
        return items;
    });
}
exports.default = distinct;
}
// default/queries/limit.js
_a8cc.f[12] = function(module,exports){
Object.defineProperty(exports, '__esModule', { value: true });
var isNumber = _a8cc.s('lodash/isNumber');
function default_1(limit) {
    return function (items) {
        if (isNumber(limit)) {
            if (items.length > limit) {
                return items.slice(0, limit);
            } else {
                return items;
            }
        }
    };
}
exports.default = default_1;
}
// default/utils/traverse.js
_a8cc.f[13] = function(module,exports){
var __importDefault = this && this.__importDefault || function (mod) {
    return mod && mod.__esModule ? mod : { 'default': mod };
};
Object.defineProperty(exports, '__esModule', { value: true });
var isObject_1 = __importDefault(_a8cc.r(8));
var isNull_1 = __importDefault(_a8cc.r(14));
var isUndefined_1 = __importDefault(_a8cc.r(15));
function traverseFilter(obj, queries, item) {
    for (var i in obj) {
        if (!isNull_1.default(obj[i]) && !isUndefined_1.default(obj[i]) && isObject_1.default(obj[i])) {
            traverseFilter(obj[i], queries, item);
        } else {
            var query = queries[i];
            if (query) {
            }
        }
    }
    return obj;
}
exports.traverseFilter = traverseFilter;
}
// default/utils/isNull.js
_a8cc.f[14] = function(module,exports){
Object.defineProperty(exports, '__esModule', { value: true });
function default_1(val) {
    return val === null;
}
exports.default = default_1;
}
// default/utils/isUndefined.js
_a8cc.f[15] = function(module,exports){
Object.defineProperty(exports, '__esModule', { value: true });
function default_1(val) {
    return val === undefined;
}
exports.default = default_1;
}
// default/queries/index.js
_a8cc.f[16] = function(module,exports){
var __importDefault = this && this.__importDefault || function (mod) {
    return mod && mod.__esModule ? mod : { 'default': mod };
};
Object.defineProperty(exports, '__esModule', { value: true });
var logical_1 = __importDefault(_a8cc.r(17));
var comparison_1 = __importDefault(_a8cc.r(18));
var filter_1 = __importDefault(_a8cc.r(19));
var sort_1 = __importDefault(_a8cc.r(20));
var limit_1 = __importDefault(_a8cc.r(12));
var format_1 = __importDefault(_a8cc.r(21));
var distinct_1 = __importDefault(_a8cc.r(11));
exports.operators = {
    query: Object.keys(comparison_1.default),
    queryLogical: Object.keys(logical_1.default)
};
exports.getMatcherSets = function (operator) {
    return Object.keys(operator).map(function (operatorKey) {
        return exports.getQueryValueMatchers(operatorKey, operator[operatorKey]);
    }).reduce(function (prev, next) {
        return prev.concat(next);
    });
};
exports.getQueryValueMatchers = function (itemKey, queryOperators) {
    return Object.keys(queryOperators).map(function (operatorKey) {
        return exports.getOperatorImplementation({
            key: itemKey,
            type: operatorKey,
            value: queryOperators[operatorKey]
        });
    });
};
exports.getOperatorImplementation = function (operator) {
    var operatorsImpl;
    if (exports.operators.query.indexOf(operator.type) > -1) {
        operatorsImpl = comparison_1.default;
    } else if (exports.operators.queryLogical.indexOf(operator.type) > -1) {
        operatorsImpl = logical_1.default;
    }
    return operatorsImpl[operator.type](operator.key, operator.value);
};
exports.default = {
    $filter: filter_1.default,
    $sort: sort_1.default,
    $limit: limit_1.default,
    $format: format_1.default,
    $distinct: distinct_1.default
};
}
// default/queries/logical.js
_a8cc.f[17] = function(module,exports){
Object.defineProperty(exports, '__esModule', { value: true });
var _1 = _a8cc.r(16);
var logicalQueryOperatorsImpl = {
    $and: function (key, value) {
        var matchers = value.map(_1.getMatcherSets).reduce(function (prev, next) {
            return prev.concat(next);
        }, []);
        return function (item) {
            return matchers.every(function (matcher) {
                return matcher(item);
            });
        };
    },
    $or: function (key, value) {
        var matchersSets = value.map(_1.getMatcherSets);
        return function (item) {
            return matchersSets.some(function (matchers) {
                return matchers.every(function (matcher) {
                    return matcher(item);
                });
            });
        };
    },
    $nor: function (key, value) {
        var matcher = this.$and(key, value);
        return function (item) {
            return !matcher(item);
        };
    }
};
exports.default = logicalQueryOperatorsImpl;
}
// default/queries/comparison.js
_a8cc.f[18] = function(module,exports){
Object.defineProperty(exports, '__esModule', { value: true });
var get = _a8cc.s('lodash/get');
var has = _a8cc.s('lodash/has');
var comparsionQueryOperatorsImpl = {
    $eq: function (key, value) {
        return function (item) {
            return has(item, key) && get(item, key) === value;
        };
    },
    $gt: function (key, value) {
        return function (item) {
            return has(item, key) && get(item, key) > value;
        };
    },
    $gte: function (key, value) {
        return function (item) {
            return has(item, key) && get(item, key) >= value;
        };
    },
    $lt: function (key, value) {
        return function (item) {
            return has(item, key) && get(item, key) < value;
        };
    },
    $lte: function (key, value) {
        return function (item) {
            return has(item, key) && get(item, key) <= value;
        };
    },
    $ne: function (key, value) {
        return function (item) {
            return has(item, key) && get(item, key) !== value;
        };
    },
    $in: function (key, value) {
        return function (item) {
            var statisfied = true;
            var data = get(item, key);
            if (Array.isArray(data)) {
                data.forEach(function (k) {
                    if (!value.includes(k)) {
                        statisfied = false;
                    }
                });
            } else {
                if (!value.includes(data)) {
                    statisfied = false;
                }
            }
            return statisfied;
        };
    },
    $nin: function (key, value) {
        return function (item) {
            var statisfied = true;
            var data = get(item, key);
            if (Array.isArray(data)) {
                data.forEach(function (k) {
                    if (value.includes(k)) {
                        statisfied = false;
                    }
                });
            } else {
                if (value.includes(data)) {
                    statisfied = false;
                }
            }
            return statisfied;
        };
    },
    $regex: function (key, value, flags) {
        return function (item) {
            var val = value;
            if (val instanceof RegExp) {
                return has(item, key) && val.test(get(item, key));
            }
            return has(item, key) && new RegExp(val, flags || 'g').test(get(item, key));
        };
    }
};
exports.default = comparsionQueryOperatorsImpl;
}
// default/queries/filter.js
_a8cc.f[19] = function(module,exports){
var __importDefault = this && this.__importDefault || function (mod) {
    return mod && mod.__esModule ? mod : { 'default': mod };
};
Object.defineProperty(exports, '__esModule', { value: true });
var comparison_1 = __importDefault(_a8cc.r(18));
var logical_1 = __importDefault(_a8cc.r(17));
var isObject = _a8cc.s('lodash/isObject');
var util_1 = _a8cc.r(10);
var queuePrefix = 'filter.';
function filterQueue(spec) {
    var matchers = [];
    return function (results, keys) {
        keys = keys.filter(function (k) {
            return k.startsWith(queuePrefix);
        }).map(function (k) {
            return k.replace(queuePrefix, '');
        });
        for (var key in spec) {
            if (keys.includes(key)) {
                if (logical_1.default[key]) {
                    matchers.push(logical_1.default[key](key, spec[key]));
                    continue;
                }
                if (isObject(spec[key])) {
                    for (var k in spec[key]) {
                        if (comparison_1.default[k]) {
                            matchers.push(comparison_1.default[k](key, spec[key][k]));
                        }
                    }
                } else {
                    matchers.push(comparison_1.default['$eq'](key, spec[key]));
                }
            }
        }
        return results.filter(function (item) {
            var statisfied = [];
            for (var _i = 0, matchers_1 = matchers; _i < matchers_1.length; _i++) {
                var compare = matchers_1[_i];
                statisfied.push(compare(item));
            }
            return !statisfied.includes(false);
        });
    };
}
function filter(db, results, spec, queues) {
    if (results === void 0) {
        results = [];
    }
    var promise = Promise.resolve(results);
    var matchers = [];
    for (var key in spec) {
        var keyLength = key.split('.').length;
        if (keyLength > 1) {
            queues[queuePrefix + key] = filterQueue(spec);
            continue;
        }
        if (logical_1.default[key]) {
            if (util_1.isNestedQuery(spec)) {
                queues[queuePrefix + key] = filterQueue(spec);
            } else {
                matchers.push(logical_1.default[key](key, spec[key]));
            }
            continue;
        }
        if (isObject(spec[key])) {
            for (var k in spec[key]) {
                if (comparison_1.default[k]) {
                    matchers.push(comparison_1.default[k](key, spec[key][k], spec[key]['$option']));
                }
            }
        } else {
            matchers.push(comparison_1.default['$eq'](key, spec[key]));
        }
    }
    return promise.then(function (items) {
        return items.filter(function (item) {
            var statisfied = [];
            for (var _i = 0, matchers_2 = matchers; _i < matchers_2.length; _i++) {
                var compare = matchers_2[_i];
                statisfied.push(compare(item));
            }
            return !statisfied.includes(false);
        });
    });
}
exports.default = filter;
}
// default/queries/sort.js
_a8cc.f[20] = function(module,exports){
Object.defineProperty(exports, '__esModule', { value: true });
var get = _a8cc.s('lodash/get');
var queuePrefix = 'sort.';
function sortDesc(data, property) {
    return data.sort(function (a, b) {
        if (typeof b === 'object' && typeof a === 'object') {
            var d2 = get(b, property);
            var d1 = get(a, property);
            if (d2 instanceof Date && d1 instanceof Date) {
                return d2.getTime() - d1.getTime();
            } else {
                if (d2 < d1)
                    return -1;
                if (d2 > d1)
                    return 1;
                else
                    return 0;
            }
        }
        if (b instanceof Date && a instanceof Date) {
            return b.getTime() - a.getTime();
        } else {
            if (b < a)
                return -1;
            if (b > a)
                return 1;
            else
                return 0;
        }
    });
}
function sortAsc(data, property) {
    return data.sort(function (a, b) {
        if (typeof b === 'object' && typeof a === 'object') {
            var d2 = get(b, property);
            var d1 = get(a, property);
            if (d2 instanceof Date && d1 instanceof Date) {
                return a[property].getTime() - b[property].getTime();
            } else {
                if (d1 < d2)
                    return -1;
                if (d1 > d2)
                    return 1;
                else
                    return 0;
            }
        }
        if (b instanceof Date && a instanceof Date) {
            return new Date(a).getTime() - new Date(b).getTime();
        } else {
            if (a < b)
                return -1;
            if (a > b)
                return 1;
            else
                return 0;
        }
    });
}
function sortQueue(spec) {
    return function (results, keys) {
        keys = keys.filter(function (k) {
            return k.startsWith(queuePrefix);
        }).map(function (k) {
            return k.replace(queuePrefix, '');
        });
        Object.keys(spec).forEach(function (key) {
            if (keys.includes(key)) {
                if (typeof spec[key] === 'string' || typeof spec[key] === 'number')
                    results = spec[key] === 'asc' || spec[key] > 0 ? sortAsc(results, key) : sortDesc(results, key);
                else
                    throw new Error('sort value should be a string or number');
            }
        });
        return results;
    };
}
function default_1(db, results, spec, queues) {
    var promise = Promise.resolve(results);
    return promise.then(function (items) {
        for (var key in spec) {
            if (key.split('.').length > 1) {
                queues[queuePrefix + key] = sortQueue(spec);
                continue;
            }
            if (typeof spec[key] === 'string' || typeof spec[key] === 'number')
                results = spec[key] === 'asc' || spec[key] > 0 ? sortAsc(items, key) : sortDesc(items, key);
            else
                throw new Error('sort value should be a string or number');
        }
        return results;
    });
}
exports.default = default_1;
}
// default/queries/format.js
_a8cc.f[21] = function(module,exports){
var __importDefault = this && this.__importDefault || function (mod) {
    return mod && mod.__esModule ? mod : { 'default': mod };
};
Object.defineProperty(exports, '__esModule', { value: true });
var get_1 = __importDefault(_a8cc.s('lodash/get'));
var set_1 = __importDefault(_a8cc.s('lodash/set'));
var formatter_1 = _a8cc.r(22);
var queuePrefix = 'format.';
var FormatType;
(function (FormatType) {
    FormatType['DATE'] = 'date';
    FormatType['NUMBER'] = 'number';
}(FormatType = exports.FormatType || (exports.FormatType = {})));
function formatItem(item, spec, keys, queues) {
    if (!keys) {
        keys = Object.keys(spec);
    }
    for (var _i = 0, keys_1 = keys; _i < keys_1.length; _i++) {
        var key = keys_1[_i];
        var keyLength = key.split('.').length;
        if (queues && keyLength > 1) {
            queues[queuePrefix + key] = formatQueue(spec);
            continue;
        }
        if (spec[key].type) {
            var value = void 0;
            switch (spec[key].type) {
            case FormatType.DATE:
                value = formatter_1.formatDate(get_1.default(item, key), spec[key].format);
                set_1.default(item, key, value);
                break;
            case FormatType.NUMBER:
                value = formatter_1.formatNumber(get_1.default(item, key), spec[key].format, spec[key].separator);
                set_1.default(item, key, value);
                break;
            default:
            }
        } else {
            var formatter = spec[key].formatter;
            if (formatter && typeof formatter === 'function') {
                var value = formatter(get_1.default(item, key));
                set_1.default(item, key, value);
            }
        }
    }
    return item;
}
function formatQueue(spec) {
    return function (items, keys) {
        keys = keys.filter(function (k) {
            return k.startsWith(queuePrefix);
        }).map(function (k) {
            return k.replace(queuePrefix, '');
        });
        return items.map(function (item) {
            return formatItem(item, spec, keys);
        });
    };
}
exports.formatQueue = formatQueue;
function format(db, results, spec, queues) {
    if (results === void 0) {
        results = [];
    }
    var promise = Promise.resolve(results);
    return promise.then(function (items) {
        return items.map(function (item) {
            return formatItem(item, spec, null, queues);
        });
    });
}
exports.default = format;
}
// default/utils/formatter.js
_a8cc.f[22] = function(module,exports){
var __importDefault = this && this.__importDefault || function (mod) {
    return mod && mod.__esModule ? mod : { 'default': mod };
};
Object.defineProperty(exports, '__esModule', { value: true });
var moment_1 = __importDefault(_a8cc.s('moment'));
var util_1 = _a8cc.s('util');
var validate_1 = _a8cc.r(6);
function formatNumber(value, format, separator) {
    var str = value + '';
    var splittedFormat = format.split(separator);
    var regex = new RegExp(format.replace('###', '(\\d{3})').replace('#', '(\\d+)').replace(separator, ''));
    var formatStr = splittedFormat.reduce(function (prev, next, index) {
        if (!prev)
            return '$' + (index + 1);
        return prev + separator + ('$' + (index + 1));
    }, null);
    while (regex.test(str)) {
        str = str.replace(regex, formatStr);
    }
    return str;
}
exports.formatNumber = formatNumber;
function formatDate(value, format) {
    var date = value;
    if (util_1.isDate(date)) {
        date = date.getFullYear() + '/' + date.getMonth() + '/' + date.getDate();
    } else if (validate_1.isFirestoreTimestamp(date)) {
        var dt = date.toDate();
        date = dt.getFullYear() + '/' + dt.getMonth() + '/' + dt.getDate();
    }
    return moment_1.default(date, 'YYYY/MM/DD').format(format);
}
exports.formatDate = formatDate;
}
// default/utils/listenerCollection.js
_a8cc.f[23] = function(module,exports){
Object.defineProperty(exports, '__esModule', { value: true });
var forEachSeries = _a8cc.s('async/eachSeries');
var ListenerCollection = function () {
    function ListenerCollection() {
        this._listeners = [];
        this._pre = [];
        this._post = [];
        this._postFail = [];
    }
    ListenerCollection.prototype.add = function (key, context, listener) {
        this._listeners.push({
            key: key,
            fn: listener || context,
            context: listener === null ? this : context
        });
    };
    ListenerCollection.prototype.insert = function (indexOrCondition, key, context, listener) {
        var listenerOpts = {
            key: key,
            fn: listener || context,
            context: listener === null ? this : context
        };
        if (!isNaN(indexOrCondition)) {
            return this._listeners.splice(indexOrCondition, 0, listenerOpts);
        }
        var afterInsertIndex = null;
        var beforeInsertIndex = null;
        for (var i = 0; i < this._listeners.length; i++) {
            if (this._listeners[i].key === indexOrCondition.after) {
                afterInsertIndex = i + 1;
            }
            if (this._listeners[i].key === indexOrCondition.before) {
                beforeInsertIndex = i;
            }
        }
        var index = afterInsertIndex !== null ? afterInsertIndex : beforeInsertIndex !== null ? beforeInsertIndex : this._listeners.length;
        this._listeners.splice(index, 0, listenerOpts);
    };
    ListenerCollection.prototype.remove = function (key) {
        this._listeners = this._listeners.filter(function (l) {
            return l.key !== key;
        });
    };
    ListenerCollection.prototype.pre = function (fn) {
        this._pre.push(fn);
    };
    ListenerCollection.prototype.post = function (fn) {
        this._post.push(fn);
    };
    ListenerCollection.prototype.postFail = function (fn) {
        this._postFail.push(fn);
    };
    ListenerCollection.prototype.fireAndJoinResults = function () {
        return this.fire.apply(this, arguments).then(function (results) {
            var successes = results.filter(function (r) {
                return r === true;
            });
            var failures = results.filter(function (r) {
                return r === false;
            });
            var dontCares = results.filter(function (r) {
                return r === null || r === undefined;
            });
            if (successes.length && successes.length + dontCares.length === results.length) {
                return true;
            }
            if (failures.length && failures.length + dontCares.length === results.length) {
                return false;
            }
            if (dontCares.length === results.length) {
                return null;
            }
            return true;
        });
    };
    ListenerCollection.prototype.fire = function () {
        var args = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            args[_i] = arguments[_i];
        }
        var self = this;
        args = Array.prototype.slice.call(arguments, 0);
        var usePromises = args.length === 0 || !(typeof args[args.length - 1] === 'function');
        function mapSeries(arr, iterator) {
            var currentPromise = Promise.resolve();
            var promises = arr.map(function (el) {
                return currentPromise = currentPromise.then(function () {
                    return iterator(el);
                });
            });
            return Promise.all(promises);
        }
        function applyHook(l, hookArrayNane, outerArgs) {
            self[hookArrayNane].forEach(function (p) {
                p.apply(l, outerArgs);
            });
        }
        if (usePromises) {
            var results = [];
            return mapSeries(this._listeners, function (l) {
                var currentArgs = args.slice(0);
                applyHook(l, '_pre', currentArgs);
                try {
                    var valOrPromise = l.fn.apply(l.context, currentArgs);
                    return Promise.resolve(valOrPromise).then(function (val) {
                        applyHook(l, '_post', currentArgs);
                        results.push(val);
                        return Promise.resolve(val);
                    }).catch(function (err) {
                        currentArgs.unshift(err);
                        applyHook(l, '_postFail', currentArgs);
                        return Promise.reject(err);
                    });
                } catch (e) {
                    currentArgs.unshift(e);
                    applyHook(l, '_postFail', currentArgs);
                    return Promise.reject(e);
                }
            }).then(function () {
                return results;
            });
        }
        args.pop();
        return forEachSeries(this._listeners, function (l, next) {
            var currentArgs = args.slice(0);
            currentArgs.push(next);
            l.fn.apply(l.context, currentArgs);
        }, arguments[arguments.length - 1]);
    };
    return ListenerCollection;
}();
exports.default = ListenerCollection;
}
// default/network/index.js
_a8cc.f[24] = function(module,exports){
var NetworkProvider;
if (false) {
    NetworkProvider = _a8cc.r(25);
} else {
    NetworkProvider = _a8cc.r(26);
}
module.exports = NetworkProvider;
}
// default/network/browser.js
_a8cc.f[25] = function(module,exports){
var __extends = this && this.__extends || function () {
    var extendStatics = Object.setPrototypeOf || { __proto__: [] } instanceof Array && function (d, b) {
        d.__proto__ = b;
    } || function (d, b) {
        for (var p in b)
            if (b.hasOwnProperty(p))
                d[p] = b[p];
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() {
            this.constructor = d;
        }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
}();
Object.defineProperty(exports, '__esModule', { value: true });
var util_1 = _a8cc.r(10);
exports.EventEmitter = _a8cc.s('eventemitter3');
var NetworkProvider = function (_super) {
    __extends(NetworkProvider, _super);
    function NetworkProvider() {
        var _this = _super.call(this) || this;
        _this.connected = navigator.onLine;
        if (!util_1.isInWorker()) {
            window.addEventListener('online', function () {
                _this.connected = true;
                _this.emit('online');
            });
            window.addEventListener('offline', function () {
                _this.connected = false;
                _this.emit('offline');
            });
        }
        return _this;
    }
    return NetworkProvider;
}(exports.EventEmitter);
module.exports = NetworkProvider;
module.exports.default = NetworkProvider;
}
// default/network/node.js
_a8cc.f[26] = function(module,exports){
var __extends = this && this.__extends || function () {
    var extendStatics = Object.setPrototypeOf || { __proto__: [] } instanceof Array && function (d, b) {
        d.__proto__ = b;
    } || function (d, b) {
        for (var p in b)
            if (b.hasOwnProperty(p))
                d[p] = b[p];
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() {
            this.constructor = d;
        }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
}();
Object.defineProperty(exports, '__esModule', { value: true });
var dns_1 = _a8cc.s('dns');
var EventEmitter = _a8cc.s('eventemitter3');
var NetworkProvider = function (_super) {
    __extends(NetworkProvider, _super);
    function NetworkProvider() {
        var _this = _super.call(this) || this;
        _this.connected = false;
        dns_1.resolve('www.google.com', function (err) {
            if (err) {
                _this.connected = false;
                _this.emit('offline');
            } else {
                _this.connected = true;
                _this.emit('online');
            }
        });
        setInterval(function () {
            dns_1.resolve('www.google.com', function (err) {
                if (err) {
                    _this.connected = false;
                    _this.emit('offline');
                } else {
                    _this.connected = true;
                    _this.emit('online');
                }
            });
        }, 1000);
        return _this;
    }
    return NetworkProvider;
}(EventEmitter);
module.exports = NetworkProvider;
module.exports.default = NetworkProvider;
}
module.exports = _a8cc.r(0)